// ParseTest created Jul 10, 2002 10:43:27 PM
// Copyright (c) 2002, Ward Cunningham

import junit.framework.*;

public class ParseTest extends TestCase {
    public ParseTest (String name) {
        super (name);
    }
    public void testParsing () {
        String tags[] = {"table"};
        Parse p = new Parse("leader<table foo=2>body</table>trailer", tags, 0);
        assertEquals("leader", p.leader);
        assertEquals("<table foo=2>", p.tag);
        assertEquals("body", p.body);
        assertEquals("trailer", p.trailer);
    }
    public void testRecursing () {
        Parse p = new Parse("leader<table><tr><td>body</td></tr></table>trailer");
        assertEquals("<tr><td>body</td></tr>", p.body);
        assertEquals("<td>body</td>", p.parts.body);
        assertEquals("body", p.parts.parts.body);
    }
    public void testIterating () {
        Parse p = new Parse("leader<table><tr><td>one</td><td>two</td><td>three</td></tr></table>trailer");
        assertEquals("one", p.parts.parts.body);
        assertEquals("two", p.parts.parts.more.body);
        assertEquals("three", p.parts.parts.more.more.body);
    }
    public void testIndexing () {
        Parse p = new Parse("leader<table><tr><td>one</td><td>two</td><td>three</td></tr><tr><td>four</td></tr></table>trailer");
        assertEquals("one", p.at(0,0,0).body);
        assertEquals("two", p.at(0,0,1).body);
        assertEquals("three", p.at(0,0,2).body);
        assertEquals(null, p.at(0,0,3));
        assertEquals(null, p.at(0,0,4));
        assertEquals("four", p.at(0,1,0).body);
        assertEquals(null, p.at(0,1,1));
        assertEquals(null, p.at(0,2,0));
    }
}
